## plasma-workspace 5.27.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(plasma-workspace)
set(PROJECT_VERSION "5.27.5")
set(PROJECT_VERSION_MAJOR 5)

set(QT_MIN_VERSION "5.15.2")
set(KF5_MIN_VERSION "5.102.0")
set(KDE_COMPILERSETTINGS_LEVEL "5.82")
set(INSTALL_SDDM_THEME TRUE)
option(INSTALL_SDDM_WAYLAND_SESSION OFF)
option(WITH_X11 "Build with X11 support. Building without is experimental" ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMMarkNonGuiExecutable)
include(CMakePackageConfigHelpers)
include(WriteBasicConfigVersionFile)
include(CheckIncludeFiles)
include(FeatureSummary)
include(ECMOptionalAddSubdirectory)
include(ECMQtDeclareLoggingCategory)
include(ECMQueryQt)
include(ECMInstallIcons)
include(KDEClangFormat)
include(KDEGitCommitHooks)
include(ECMConfiguredInstall)
include(ECMGenerateDBusServiceFile)
include(ECMFindQmlModule)
include(ECMGenerateExportHeader)
include(ECMGenerateQmlTypes)
include(ECMDeprecationSettings)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Svg Widgets Quick QuickWidgets Concurrent Test Network)
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
                    Auth Plasma Runner Notifications NotifyConfig NewStuff Wallet IdleTime
                    Declarative I18n KCMUtils TextWidgets Crash GlobalAccel DBusAddons Wayland
                    CoreAddons People ActivitiesStats Activities KIO Prison PlasmaQuick Package
                    GuiAddons Archive ItemModels IconThemes UnitConversion ItemModels TextEditor
                    OPTIONAL_COMPONENTS DocTools)

find_package(KDED CONFIG REQUIRED)
find_package(KPipeWire CONFIG)

find_package(KF5NetworkManagerQt ${KF5_MIN_VERSION})
set_package_properties(KF5NetworkManagerQt PROPERTIES DESCRIPTION "Qt wrapper for NetworkManager API"
                       TYPE OPTIONAL
                       PURPOSE "Needed by geolocation data engine."
                      )

find_package(KF5Kirigami2 ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5Kirigami2 PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    TYPE RUNTIME
)

find_package(KF5QuickCharts ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5QuickCharts PROPERTIES
    DESCRIPTION "Used for rendering charts"
    TYPE RUNTIME
)

find_package(KUserFeedback)
find_package(KSysGuard CONFIG REQUIRED)

find_package(KF5Baloo)
set_package_properties(KF5Baloo PROPERTIES DESCRIPTION "File Searching"
                       TYPE RECOMMENDED
                       PURPOSE "Needed for the File Search runner."
                      )

find_package(PkgConfig REQUIRED)
pkg_check_modules(QALCULATE libqalculate>2.0 REQUIRED IMPORTED_TARGET)

find_package(KWinDBusInterface CONFIG REQUIRED)

find_package(KF5Screen CONFIG REQUIRED)
find_package(KScreenLocker 5.13.80 REQUIRED)
find_package(ScreenSaverDBusInterface CONFIG REQUIRED)
find_package(LayerShellQt CONFIG REQUIRED)
find_package(KF5Holidays)
set_package_properties(KF5Holidays PROPERTIES DESCRIPTION "Holidays provider for Plasma calendar"
                       TYPE OPTIONAL
                       PURPOSE "Needed to for holidays plugin for Plasma Calendar."
                      )

find_package(Phonon4Qt${QT_MAJOR_VERSION} 4.6.60 REQUIRED NO_MODULE)
set_package_properties(Phonon4Qt${QT_MAJOR_VERSION} PROPERTIES
   DESCRIPTION "Qt-based audio library"
   TYPE REQUIRED)

find_package(Breeze ${PROJECT_VERSION} CONFIG)
set_package_properties(Breeze PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "For setting the default window decoration plugin")

find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES DESCRIPTION "Support for gzip compressed files and data streams"
                       URL "https://www.zlib.net"
                       TYPE REQUIRED
                      )

find_package(Fontconfig)
set_package_properties(Fontconfig PROPERTIES DESCRIPTION "Font access configuration library"
                       URL "https://www.freedesktop.org/wiki/Software/fontconfig"
                       TYPE OPTIONAL
                       PURPOSE "Needed to build font configuration and installation tools"
                      )

if(WITH_X11)
    find_package(X11)
    set_package_properties(X11 PROPERTIES DESCRIPTION "X11 libraries"
                            URL "https://www.x.org"
                            TYPE REQUIRED
                            PURPOSE "Required for building the X11 based workspace")
    function(check_X11_lib _lib)
        if (NOT TARGET X11::${_lib})
            message(SEND_ERROR "Required component ${_lib} of X11 was not found")
        endif()
    endfunction()
    check_X11_lib(ICE)
    check_X11_lib(SM)
    check_X11_lib(X11)
    check_X11_lib(Xau)
    check_X11_lib(Xcursor)
    check_X11_lib(Xfixes)
    check_X11_lib(Xft)
    check_X11_lib(Xrender)
    check_X11_lib(Xtst)

    set(HAVE_X11 1)
    set(HAVE_XCURSOR 1)
    set(HAVE_XFIXES 1)

    find_package(XCB MODULE REQUIRED COMPONENTS XCB RANDR IMAGE)
    set_package_properties(XCB PROPERTIES TYPE REQUIRED)

    if (QT_MAJOR_VERSION EQUAL "5")
        find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS X11Extras)
    endif()

else()
    set(HAVE_X11 0)
    set(HAVE_XCURSOR 0)
    set(HAVE_XFIXES 0)
endif()

pkg_check_modules(PipeWire IMPORTED_TARGET libpipewire-0.3)
add_feature_info(PipeWire PipeWire_FOUND "Required for Wayland screencasting")

if(PipeWire_FOUND)
  find_package(Libdrm REQUIRED)
endif()

if(QT_MAJOR_VERSION EQUAL "5")
  find_package(QtWaylandScanner REQUIRED)
  find_package(Qt5XkbCommonSupport)
else()
  find_package(Qt6 REQUIRED CONFIG COMPONENTS WaylandCompositor)
endif()
find_package(Qt${QT_MAJOR_VERSION}WaylandClient COMPONENTS Private)
find_package(PlasmaWaylandProtocols 1.6 REQUIRED)
find_package(Wayland REQUIRED COMPONENTS Client Server) # Server is used in autotests
find_package(WaylandProtocols 1.31)
set_package_properties(WaylandProtocols PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Collection of Wayland protocols that add functionality not available in the Wayland core protocol"
    URL "https://gitlab.freedesktop.org/wayland/wayland-protocols/"
)
if (WaylandProtocols_FOUND)
    set(HAVE_WaylandProtocols true)
endif()

if(FONTCONFIG_FOUND)
  # kfontinst
  find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS PrintSupport)
endif()

find_package(AppStreamQt 0.10.6)
set_package_properties(AppStreamQt PROPERTIES DESCRIPTION "Access metadata for listing available software"
                       URL "https://www.freedesktop.org/wiki/Distributions/AppStream/"
                       TYPE OPTIONAL)

if(${AppStreamQt_FOUND})
    set(HAVE_APPSTREAMQT true)
endif()


# Region & Language KCM
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    # notes for packager:
    # This is the macro definition part of Region & Language KCM
    # Depending on your distributions, the KCM behaves differently
    # For Ubuntu based systems, this KCM uses "check-language-support" and PackageKit
    # to install relevant fonts and packages
    # You should enable option UBUNTU_PACKAGEKIT (it's auto detected though)
    #
    # For Glibc systems that don't come with pre-generated locales, such as ArchLinux
    # This KCM uses "/etc/locale.gen" and "locale-gen" to generate configured locales
    # and display a note to let user install fonts themselves if required
    # You shouldn't required to do anything in this case
    #
    # For Glibc systems that come with pre-generated locales, such as Fedora and openSUSE
    # a note to let user install fonts themselves if required is displayed
    # You should enable GLIBC_LOCALE_GENERATED option
    #
    # For non-glibc systems such as VoidLinux and *BSD
    # A warning of configure locale manually is displayed (although the relevant ENVs are set by Plasma)
    # You should disable GLIBC_LOCALE_GEN option


    # find out if the build system is Ubuntu based
    if (${CMAKE_VERSION} VERSION_LESS 3.22)
        find_program(LSB_RELEASE_EXEC lsb_release)
        execute_process(COMMAND ${LSB_RELEASE_EXEC} -is
            OUTPUT_VARIABLE DISTRO_NAME
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        string(TOLOWER "${DISTRO_NAME}" DISTRO_NAME)
    else()
        cmake_host_system_information(RESULT DISTRO_NAME QUERY DISTRIB_ID)
        cmake_host_system_information(RESULT DISTRO_ID_LIKE QUERY DISTRIB_ID_LIKE)
    endif()

    string(COMPARE EQUAL "ubuntu" "${DISTRO_NAME}" SYSTEM_UBUNTU_BASED)
    string(FIND "${DISTRO_ID_LIKE}" "ubuntu" FINDINDEX)
    if(NOT (FINDINDEX EQUAL -1))
        set(SYSTEM_UBUNTU_BASED ON)
    endif()

    option(UBUNTU_PACKAGEKIT "Install required package for language on Ubuntu Based systems, PackageKitQt5 required" ${SYSTEM_UBUNTU_BASED})
    if(UBUNTU_PACKAGEKIT)
        set(OS_UBUNTU TRUE)
    endif()

    set(GLIBC_LOCALE_GEN_DEFAULT ON)
    if(UBUNTU_PACKAGEKIT)
        set(GLIBC_LOCALE_GEN_DEFAULT OFF)
    endif()

    option(GLIBC_LOCALE_GEN "Auto generate Glibc locale with locale-gen and /etc/locale.gen" ${GLIBC_LOCALE_GEN_DEFAULT})
    if(GLIBC_LOCALE_GEN AND UBUNTU_PACKAGEKIT)
        message(FATAL_ERROR "UBUNTU_PACKAGEKIT and GLIBC_LOCALE_GEN both enabled, only UBUNTU_PACKEGKIT will be used")
    endif()
    if(GLIBC_LOCALE_GEN)
        set(GLIBC_LOCALE TRUE)
    endif()
    if(UBUNTU_PACKAGEKIT OR GLIBC_LOCALE_GEN)
        set(REGION_LANG_GENERATE_LOCALE TRUE)
    endif()

    option(GLIBC_LOCALE_GENERATED "Systems that don't require locale generation. Such as openSUSE or Fedora" OFF)
    if(GLIBC_LOCALE_GENERATED)
        set(LOCALE_GENERATED TRUE)
    endif()
    if(REGION_LANG_GENERATE_LOCALE AND GLIBC_LOCALE_GENERATED)
        message(FATAL_ERROR "(UBUNTU_PACKAGEKIT || GLIBC_LOCALE_GEN) and GLIBC_LOCALE_GENERATED both enabled")
    endif()

    ################## Find libraries ###################
    if(REGION_LANG_GENERATE_LOCALE)
        find_package(PolkitQt${QT_MAJOR_VERSION}-1)
        set_package_properties(PolkitQt${QT_MAJOR_VERSION}-1
                PROPERTIES DESCRIPTION "DBus interface wrapper for Polkit"
                PURPOSE "Communicate with localegen helper in region & lang kcm"
                TYPE REQUIRED
        )
    endif()

    if(UBUNTU_PACKAGEKIT)
        find_package(PackageKitQt${QT_MAJOR_VERSION})
        set_package_properties(PackageKitQt${QT_MAJOR_VERSION}
                PROPERTIES DESCRIPTION "Software Manager integration"
                TYPE OPTIONAL
                PURPOSE "Used to install additional language packages on demand"
                )

    endif()
endif()

find_package(ICU COMPONENTS i18n uc)
set_package_properties(ICU
        PROPERTIES DESCRIPTION "Unicode and Globalization support for software applications"
        TYPE OPTIONAL
        PURPOSE "Better application groups in Kicker"
        )
if(${ICU_FOUND})
    set(HAVE_ICU TRUE)
endif()

find_package(KF5KExiv2)
set_package_properties(KF5KExiv2
        PROPERTIES URL "https://www.exiv2.org" DESCRIPTION "Image metadata support"
        TYPE OPTIONAL
        PURPOSE "Provides metadata for image wallpaper plugin"
        )
if(${KF5KExiv2_FOUND})
    set(HAVE_KF5KExiv2 TRUE)
endif()

find_package(KIOExtras)
set_package_properties(KIOExtras PROPERTIES DESCRIPTION "Common KIO slaves for operations."
                                       PURPOSE "Show thumbnails in wallpaper selection."
                                       TYPE RUNTIME
                                        )

find_package(KIOFuse)
set_package_properties(KIOFuse PROPERTIES DESCRIPTION "Provide KIO support to legacy applications. "
                                      TYPE RUNTIME
                                      )

# Clipboard applet
ecm_find_qmlmodule(org.kde.prison 1.0)

# Is building in KDE CI
if(DEFINED ENV{KDECI_BUILD})

=== applets/CMakeLists.txt ===
plasma_install_package(activitybar org.kde.plasma.activitybar)
add_subdirectory(icon)

plasma_install_package(analog-clock org.kde.plasma.analogclock)
plasma_install_package(lock_logout org.kde.plasma.lock_logout)
plasma_install_package(manage-inputmethod org.kde.plasma.manage-inputmethod)

add_subdirectory(appmenu)
add_subdirectory(systemmonitor)
add_subdirectory(batterymonitor)
add_subdirectory(calendar)
add_subdirectory(devicenotifier)
add_subdirectory(digital-clock)
add_subdirectory(kicker)
add_subdirectory(mediacontroller)
add_subdirectory(panelspacer)

plasma_install_package(clipboard org.kde.plasma.clipboard)

if(NOT WIN32)
#    #notifications
#    #should compile also on windows? (even if doesn't really make sense)
    add_subdirectory(notifications)
    add_subdirectory(systemtray)
endif()

=== gmenu-dbusmenu-proxy/CMakeLists.txt ===
find_package(AppMenuGtkModule)
set_package_properties(AppMenuGtkModule PROPERTIES TYPE RUNTIME)

add_definitions(-DQT_NO_CAST_TO_ASCII
-DQT_NO_CAST_FROM_ASCII
-DQT_NO_CAST_FROM_BYTEARRAY)

find_package(XCB
    REQUIRED COMPONENTS
        XCB
)

set(GMENU_DBUSMENU_PROXY_SRCS
    main.cpp
    menuproxy.cpp
    window.cpp
    menu.cpp
    actions.cpp
    gdbusmenutypes_p.cpp
    icons.cpp
    utils.cpp
    ../libdbusmenuqt/dbusmenutypes_p.cpp
 )

qt_add_dbus_adaptor(GMENU_DBUSMENU_PROXY_SRCS ../libdbusmenuqt/com.canonical.dbusmenu.xml window.h Window)

ecm_qt_declare_logging_category(GMENU_DBUSMENU_PROXY_SRCS HEADER debug.h
                                               IDENTIFIER DBUSMENUPROXY
                                               CATEGORY_NAME kde.dbusmenuproxy
                                               DEFAULT_SEVERITY Info)

add_executable(gmenudbusmenuproxy ${GMENU_DBUSMENU_PROXY_SRCS})

set_package_properties(XCB PROPERTIES TYPE REQUIRED)

target_link_libraries(gmenudbusmenuproxy
    Qt::Core
    Qt::DBus
    KF5::CoreAddons
    KF5::ConfigCore
    KF5::WindowSystem
    XCB::XCB
)
if (QT_MAJOR_VERSION EQUAL "5")
    target_link_libraries(gmenudbusmenuproxy Qt::X11Extras)
else()
    target_link_libraries(gmenudbusmenuproxy Qt::GuiPrivate)
endif()

install(TARGETS gmenudbusmenuproxy ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES gmenudbusmenuproxy.desktop DESTINATION ${KDE_INSTALL_AUTOSTARTDIR})

ecm_install_configured_files(INPUT plasma-gmenudbusmenuproxy.service.in @ONLY DESTINATION ${KDE_INSTALL_SYSTEMDUSERUNITDIR})

=== interactiveconsole/CMakeLists.txt ===
set(interactiveconsole_SRCS
    interactiveconsole.cpp
    main.cpp
)

add_executable(plasma-interactiveconsole ${interactiveconsole_SRCS})
target_link_libraries(plasma-interactiveconsole Qt::Widgets Qt::DBus KF5::KIOCore KF5::WidgetsAddons KF5::ConfigWidgets KF5::WindowSystem KF5::TextEditor KF5::Package)
install(TARGETS plasma-interactiveconsole ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== ktimezoned/CMakeLists.txt ===
if (WIN32)
    set(kded_ktimezoned_SRCS ktimezoned_win.cpp ktimezoned_win.h)
else ()
    set(kded_ktimezoned_SRCS ktimezoned.cpp ktimezoned.h)
endif ()

kcoreaddons_add_plugin(ktimezoned SOURCES ${kded_ktimezoned_SRCS}  INSTALL_NAMESPACE "kf${QT_MAJOR_VERSION}/kded")

#qt_add_dbus_adaptor(kded_ktimezoned_SRCS org.kde.KTimeZoned ktimezonedbus.h DBusHandler)

target_link_libraries(ktimezoned
   Qt::Core
   Qt::DBus
   KF5::Service    # plugin factory
   KF5::CoreAddons # KDirWatch
   KF5::DBusAddons # kdedmodule
   KF5::ConfigCore # KConfig[Group]
)

=== libcolorcorrect/CMakeLists.txt ===
add_subdirectory(declarative)
add_subdirectory(kded)

set(colorcorrect_LIB_SRCS
    compositorcoloradaptor.cpp
    geolocator.cpp
    suncalc.cpp
    )

add_library(colorcorrect ${colorcorrect_LIB_SRCS})
add_library(PW::LibColorCorrect ALIAS colorcorrect)

generate_export_header(colorcorrect)

target_include_directories(colorcorrect PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>" "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/colorcorrect>")

target_link_libraries(colorcorrect
                    PUBLIC
                      KF5::Plasma

                      Qt::Core
                      Qt::Quick
                    PRIVATE
                      KF5::I18n

                      Qt::DBus)

set_target_properties(colorcorrect PROPERTIES
                      VERSION ${PROJECT_VERSION}
                      SOVERSION ${PROJECT_VERSION_MAJOR}
                      EXPORT_NAME LibColorCorrect)

install(TARGETS colorcorrect EXPORT libcolorcorrectLibraryTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES
    colorcorrectconstants.h
    compositorcoloradaptor.h
    geolocator.h
    ${CMAKE_CURRENT_BINARY_DIR}/colorcorrect_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/colorcorrect COMPONENT Devel
)

write_basic_config_version_file(${CMAKE_CURRENT_BINARY_DIR}/LibColorCorrectConfigVersion.cmake VERSION "${PROJECT_VERSION}" COMPATIBILITY AnyNewerVersion)

set(CMAKECONFIG_INSTALL_DIR ${KDE_INSTALL_CMAKEPACKAGEDIR}/LibColorCorrect)

configure_package_config_file(LibColorCorrectConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/LibColorCorrectConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LibColorCorrectConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/LibColorCorrectConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(EXPORT libcolorcorrectLibraryTargets
        NAMESPACE PW::
        DESTINATION ${CMAKECONFIG_INSTALL_DIR}
        FILE LibColorCorrectLibraryTargets.cmake )

=== libdbusmenuqt/CMakeLists.txt ===
set(libdbusmenu_SRCS
dbusmenuimporter.cpp
dbusmenushortcut_p.cpp
dbusmenutypes_p.cpp
utils.cpp
dbusmenuimporter.h
dbusmenushortcut_p.h
dbusmenutypes_p.h
)

ecm_qt_declare_logging_category(libdbusmenu_SRCS HEADER debug.h
                                            IDENTIFIER DBUSMENUQT
                                            CATEGORY_NAME org.kde.libdbusmenuqt
                                            DEFAULT_SEVERITY Info)

set_source_files_properties(com.canonical.dbusmenu.xml PROPERTIES
   NO_NAMESPACE true
   INCLUDE "dbusmenutypes_p.h"
   CLASSNAME DBusMenuInterface
)
qt_add_dbus_interface(libdbusmenu_SRCS com.canonical.dbusmenu.xml dbusmenu_interface)


add_library(dbusmenuqt STATIC ${libdbusmenu_SRCS})
target_link_libraries(dbusmenuqt
    Qt::DBus
    Qt::Widgets
)

set_property(TARGET dbusmenuqt PROPERTY POSITION_INDEPENDENT_CODE ON)

add_subdirectory(test)

=== logout-greeter/CMakeLists.txt ===
set(LOGOUT_GREETER_SRCS main.cpp greeter.cpp shutdowndlg.cpp)
ecm_qt_declare_logging_category(LOGOUT_GREETER_SRCS HEADER debug.h
                                IDENTIFIER LOGOUT_GREETER
                                CATEGORY_NAME kde.logout_greeter
                                DEFAULT_SEVERITY Info)


qt_add_dbus_adaptor( LOGOUT_GREETER_SRCS ../ksmserver/org.kde.LogoutPrompt.xml greeter.h Greeter)
add_executable(ksmserver-logout-greeter ${LOGOUT_GREETER_SRCS})
target_link_libraries(ksmserver-logout-greeter
    PW::KWorkspace
    Qt::Widgets
    Qt::Quick
    Qt::DBus
    KF5::I18n
    KF5::Package
    KF5::QuickAddons
    KF5::WindowSystem
    KF5::ConfigCore
    X11::X11
    LayerShellQt::Interface
)
if (QT_MAJOR_VERSION EQUAL "5")
    target_link_libraries(ksmserver-logout-greeter Qt::X11Extras)
else()
    target_link_libraries(ksmserver-logout-greeter Qt::GuiPrivate)
endif()
install(TARGETS ksmserver-logout-greeter DESTINATION ${KDE_INSTALL_LIBEXECDIR})
kdbusaddons_generate_dbus_service_file(ksmserver-logout-greeter org.kde.LogoutPrompt ${KDE_INSTALL_FULL_LIBEXECDIR})

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== plasmacalendarintegration/CMakeLists.txt ===
add_definitions("-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII")
add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)

kcoreaddons_add_plugin(holidaysevents SOURCES holidaysevents.cpp INSTALL_NAMESPACE "plasmacalendarplugins")
target_link_libraries(holidaysevents Qt::Core
                                     KF5::ConfigCore
                                     KF5::Holidays
                                     KF5::CalendarEvents
)

install (FILES HolidaysConfig.qml
         DESTINATION ${KDE_INSTALL_PLUGINDIR}/plasmacalendarplugins/holidays
)

add_subdirectory(qmlhelper)

=== components/containmentlayoutmanager/CMakeLists.txt ===


set(containmentlayoutmanagerplugin_SRCS
    containmentlayoutmanagerplugin.cpp
    appletcontainer.cpp
    configoverlay.cpp
    appletslayout.cpp
    abstractlayoutmanager.cpp
    gridlayoutmanager.cpp
    itemcontainer.cpp
    resizehandle.cpp
    )

add_library(containmentlayoutmanagerplugin ${containmentlayoutmanagerplugin_SRCS})

target_link_libraries(containmentlayoutmanagerplugin
        PUBLIC
            Qt::Core
        PRIVATE
            Qt::Qml Qt::Quick
            KF5::Plasma KF5::PlasmaQuick
    )

ecm_qt_declare_logging_category(containmentlayoutmanagerplugin
    HEADER containmentlayoutmanager_debug.h
    IDENTIFIER CONTAINMENTLAYOUTMANAGER_DEBUG
    CATEGORY_NAME org.kde.plasma.containmentlayoutmanager
)

install(TARGETS containmentlayoutmanagerplugin DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/private/containmentlayoutmanager)

install(DIRECTORY qml/ DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/private/containmentlayoutmanager)

=== components/keyboardlayout/CMakeLists.txt ===
set(keyboardlayoutplugin_SRCS
    keyboardlayout.cpp
    keyboardlayoutplugin.cpp
    layoutnames.cpp
    virtualkeyboard.cpp
)

ecm_qt_declare_logging_category(keyboardlayoutplugin_SRCS HEADER debug.h
    IDENTIFIER KEYBOARD_LAYOUT
    CATEGORY_NAME kde.keyboardlayout
    DEFAULT_SEVERITY Info)

set_source_files_properties(org.kde.KeyboardLayouts.xml
        PROPERTIES INCLUDE layoutnames.h)

qt_add_dbus_interface(keyboardlayoutplugin_SRCS "org.kde.KeyboardLayouts.xml" keyboard_layout_interface)
qt_add_dbus_interface(keyboardlayoutplugin_SRCS "${KWIN_VIRTUALKEYBOARD_INTERFACE}" virtualkeyboard_interface)

add_library(keyboardlayoutplugin SHARED ${keyboardlayoutplugin_SRCS})

target_link_libraries(keyboardlayoutplugin Qt::Core
                                           Qt::DBus
                                           Qt::Qml)

set(keyboardlayoutplugin_PATH /org/kde/plasma/workspace/keyboardlayout)
install(TARGETS keyboardlayoutplugin
  DESTINATION ${KDE_INSTALL_QMLDIR}${keyboardlayoutplugin_PATH})
install(FILES qmldir
  DESTINATION ${KDE_INSTALL_QMLDIR}${keyboardlayoutplugin_PATH})

=== components/lookandfeelqml/CMakeLists.txt ===
set(lookandfeelqmlplugin_SRCS
    lookandfeelqmlplugin.cpp
    kpackageinterface.cpp
)

add_library(lookandfeelqmlplugin SHARED ${lookandfeelqmlplugin_SRCS})
target_link_libraries(lookandfeelqmlplugin
    Qt::Qml
    KF5::ConfigCore
    KF5::Package
)

install(TARGETS lookandfeelqmlplugin DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/lookandfeel)

install(FILES qmldir DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/lookandfeel)

=== debian/changelog ===
plasma-workspace (4:5.27.5-2+deb12u2) bookworm-security; urgency=medium

  * Non-maintainer upload.
  * CVE-2024-36041: ksmserver: Unauthorized users can access session manager

 -- Adrian Bunk <bunk@debian.org>  Fri, 21 Jun 2024 20:58:15 +0300

plasma-workspace (4:5.27.5-2+deb12u1) bookworm; urgency=medium

  * Backport patch to fix crash in krunner (Closes: #1037557).

 -- Patrick Franz <deltaone@debian.org>  Wed, 16 Aug 2023 21:18:49 +0200

plasma-workspace (4:5.27.5-2) unstable; urgency=medium

  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 27 May 2023 18:23:46 +0200

plasma-workspace (4:5.27.5-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.27.5).
  * Update build-deps and deps with the info from cmake.
  * Update symbols from buildlogs.

 -- Patrick Franz <deltaone@debian.org>  Tue, 09 May 2023 23:28:49 +0200

=== debian/control ===
Source: plasma-workspace
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Patrick Franz <deltaone@debian.org>,
           Scarlett Moore <sgmoore@kde.org>,
Build-Depends: baloo-kf5-dev (>= 5.13~),
               breeze-dev (>= 4:5.27.5~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.102.0~),
               iso-codes,
               kded5-dev (>= 5.82.0~),
               kinit-dev (>= 5.94~),
               kirigami2-dev (>= 5.102.0~),
               kquickcharts-dev (>= 5.102.0~),
               kscreenlocker-dev (>= 5.27.5~),
               kuserfeedback-dev,
               kwin-dev (>= 4:5.27.5~),
               libappstreamqt-dev (>= 0.10.6~) [linux-any],
               libdbusmenu-qt5-dev,
               libdrm-dev,
               libfontconfig-dev,
               libgps-dev,
               libicu-dev,
               libkf5activities-dev (>= 5.102.0~),
               libkf5activitiesstats-dev (>= 5.102.0~),
               libkf5archive-dev (>= 5.102.0~),
               libkf5auth-dev (>= 5.102.0~),
               libkf5config-dev (>= 5.94.0~),
               libkf5coreaddons-dev (>= 5.102.0~),
               libkf5crash-dev (>= 5.102.0~),
               libkf5dbusaddons-dev (>= 5.102.0~),
               libkf5declarative-dev (>= 5.102.0~),
               libkf5doctools-dev (>= 5.102.0~),
               libkf5globalaccel-dev (>= 5.102.0~),
               libkf5guiaddons-dev (>= 5.102.0~),
               libkf5holidays-dev (>= 5.89~),
               libkf5i18n-dev (>= 5.102.0~),
               libkf5iconthemes-dev (>= 5.102.0~),
               libkf5idletime-dev (>= 5.102.0~),
               libkf5itemmodels-dev (>= 5.102.0~),
               libkf5kcmutils-dev (>= 5.102.0~),
               libkf5kexiv2-dev,
               libkf5kio-dev (>= 5.102.0~),
               libkf5networkmanagerqt-dev (>= 5.102.0~),
               libkf5newstuff-dev (>= 5.102.0~),
               libkf5notifications-dev (>= 5.102.0~),
               libkf5notifyconfig-dev (>= 5.102.0~),
               libkf5package-dev (>= 5.102.0~),
               libkf5people-dev (>= 5.102.0~),
               libkf5plasma-dev (>= 5.102.0~),
               libkf5prison-dev (>= 5.102.0~),
               libkf5runner-dev (>= 5.102.0~),
               libkf5screen-dev (>= 4:5.27.5~),
               libkf5solid-dev,
               libkf5sysguard-dev (>= 4:5.27.5~),
               libkf5texteditor-dev (>= 5.102.0~),
               libkf5textwidgets-dev (>= 5.102.0~),
               libkf5unitconversion-dev (>= 5.102.0~),
               libkf5wallet-dev (>= 5.102.0~),
               libkf5wayland-dev (>= 4:5.102.0~),
               libkpipewire-dev,
               liblayershellqtinterface-dev (>= 5.27.5~),
               libpackagekitqt5-dev,
               libphonon4qt5-dev (>= 4:4.8.0-5),
               libphonon4qt5experimental-dev,
               libpipewire-0.3-dev,
               libpolkit-qt5-1-dev,
               libqalculate-dev (>= 2.0~),
               libqt5svg5-dev (>= 5.15.2~),
               libqt5waylandclient5-dev,
               libqt5x11extras5-dev (>= 5.15.2~),
               libsm-dev,
               libudev-dev,
               libwayland-dev (>= 1.15~),
               libx11-dev,
               libx11-xcb-dev,
               libxcb-composite0-dev,
               libxcb-damage0-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-shm0-dev,
               libxcb-util-dev,
               libxcb1-dev,
               libxcursor-dev,
               libxft-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbfile-dev,
               libxrandr-dev,
               libxrender-dev,
               libxtst-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.18~),
               plasma-framework (>= 5.89~),
               plasma-wayland-protocols (>= 1.6~),
               qtbase5-dev (>= 5.15.2~),
               qtbase5-private-dev,
               qtdeclarative5-dev (>= 5.15.2~),
               qtwayland5-dev-tools,
               qtwayland5-private-dev,
               wayland-protocols (>= 1.31~),
               xcb-proto,
               zlib1g-dev,
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/plasma/plasma-workspace
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/plasma-workspace
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/plasma-workspace.git
Rules-Requires-Root: no

Package: libcolorcorrect5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 ColorCorrect library.
 .
 This package contains library files.

Package: libkfontinst5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Tools and widgets for the desktop library
 Plasma Desktop offers a beautiful looking desktop
 that takes complete advantage of modern computing technology.
 Through the use of visual effects and scalable graphics,
 the desktop experience is not only smooth but also pleasant
 to the eye. The looks of Plasma Desktop not only provide beauty,
 they are also used to support and improve your computer
 activities effectively, without being distracting.
 .
 This package is part of the KDE Plasma.

Package: libkfontinstui5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Tools and widgets for the desktop library
 Plasma Desktop offers a beautiful looking desktop
 that takes complete advantage of modern computing technology.
 Through the use of visual effects and scalable graphics,
 the desktop experience is not only smooth but also pleasant
 to the eye. The looks of Plasma Desktop not only provide beauty,
 they are also used to support and improve your computer
 activities effectively, without being distracting.
 .
 This package is part of the KDE Plasma.

Package: libkworkspace5-5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Kworkspace library.
 .
 This package contains library files.

Package: libnotificationmanager1
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Taskmanager library.
 .
 This package contains library files.

Package: libplasma-geolocation-interface5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Interface library for geolocation.
 .
 This package contains library files.

Package: libtaskmanager6abi1
X-Debian-ABI: 1
X-CMake-Target: taskmanager
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Taskmanager library.
 .
 This package contains library files.

Package: libweather-ion7
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Weather_ion library.
 .
 This package contains library files.

Package: plasma-workspace
Architecture: any
Depends: default-dbus-session-bus | dbus-session-bus,
         drkonqi (>= 5.27.5~),
         frameworkintegration,
         gdb-minimal | gdb,
         iso-codes,
         kactivitymanagerd (>= 5.27.5~),
         kded5,
         kinit,
         kio,
         kwin-common (>= 4:5.27.5~),
         libkf5config-bin,
         libkf5globalaccel-bin (>= 5.7.0),
         libkf5plasma5 (>= 5.89~),
         libkf5service-bin,
         milou (>= 4:5.27.5~),
         plasma-framework,
         plasma-integration (>= 5.27.5~),
         plasma-workspace-data (>= ${source:Version}),
         qdbus-qt5,
         qml-module-org-kde-draganddrop,
         qml-module-org-kde-kcoreaddons,
         qml-module-org-kde-kholidays,
         qml-module-org-kde-kquickcontrols,
         qml-module-org-kde-kquickcontrolsaddons,
         qml-module-org-kde-ksysguard,
         qml-module-org-kde-kwindowsystem,
         qml-module-org-kde-prison,
         qml-module-org-kde-quickcharts,
         qml-module-org-kde-solid,
         qml-module-org-kde-userfeedback,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qtgraphicaleffects,
         qml-module-qtqml-models2,
         qml-module-qtquick-controls,
         qml-module-qtquick-dialogs,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         udisks2,
         x11-utils,
         x11-xserver-utils,
         ${misc:Depends},
         ${shlibs:Depends},
Provides: notification-daemon, x-session-manager,
Recommends: kde-cli-tools (>= 4:5.27.5~),
            kio-extras,
            ksystemstats (>= 5.27.5~),
            libpam-kwallet5 (>= 5.14),
            powerdevil (>= 4:5.14),
            qml-module-org-kde-pipewire,
            systemsettings,
Breaks: breeze (<< 4:5.23.90~),
        plasma-desktop (<< 4:5.22.90),
        plasma-desktop-data (<< 4:5.22.90),
Replaces: breeze (<< 4:5.23.90~),
          plasma-desktop (<< 4:5.22.90),
          plasma-desktop-data (<< 4:5.22.90),
Description: Plasma Workspace for KF5
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.

Package: plasma-workspace-data
Architecture: all
Depends: ${misc:Depends},
Breaks: breeze (<< 4:5.23.90~),
        plasma-desktop (<< 4:5.24.0),
        plasma-desktop-data (<< 4:5.27.0),
Replaces: breeze (<< 4:5.23.90~),
          plasma-desktop (<< 4:5.24.0),
          plasma-desktop-data (<< 4:5.27.0),
Description: Plasma Workspace for KF5 - data files
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 This contains the data files for the Plasma workspace.

Package: plasma-workspace-dev
Architecture: any
Section: libdevel
Depends: kquickcharts-dev (>= 5.102.0~),
         libkf5itemmodels-dev (>= 5.102.0~),
         libkf5plasma-dev (>= 5.102.0~),
         libkf5sysguard-dev (>= 4:5.18),
         libkf5windowsystem-dev (>= 5.89~),
         qtbase5-dev (>= 5.15.2~),
         qtdeclarative5-dev (>= 5.15.2~),
         ${misc:Depends},
         ${so:Depends},
Breaks: plasma-desktop-dev (<< 4:5.20),
Replaces: plasma-desktop-dev (<< 4:5.20),
Description: Plasma Workspace for KF5 devel files
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 This package contains the development files.

Package: plasma-workspace-wayland
Architecture: any
Depends: kwayland-integration (>= 5.27.5~),
         kwin-wayland (>= 4:5.27.5~),
         plasma-workspace (= ${binary:Version}),
         qtwayland5,
